#ifndef _IIC_H_
#define _IIC_H_

//Ƭͷļ
#include "stm32g4xx.h"


//
#define IIC_OK		0
#define IIC_ERR		1
#define ACK		    0
#define NACK		1

#define WaitAckTime 5000

//si47xx IIC˿ڶ

//IIC2---Si47xx
#define Si47xx_SDA_H	 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_7, GPIO_PIN_SET)
#define Si47xx_SDA_L	 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_7, GPIO_PIN_RESET)
#define Si47xx_SCL_H	 HAL_GPIO_WritePin(GPIOA, GPIO_PIN_15, GPIO_PIN_SET)
#define Si47xx_SCL_L	 HAL_GPIO_WritePin(GPIOA, GPIO_PIN_15, GPIO_PIN_RESET)
#define Si47xx_SDA_R	 HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_7)


//ṹ嶨
typedef struct
{
	unsigned short IIC_Speed;

} IIC_ControlDef;
extern IIC_ControlDef IIC_ControlStruct;

//
void IIC_SpeedCtl ( unsigned short Speed );
unsigned short IIC_Read_Speed ( void );
void Si47xx_IIC_Init ( void );
void Pcf8563_IIC_Init ( void );
void Si47xx_IIC_Start ( void );
void Pcf8563_IIC_Start ( void );
void Si47xx_IIC_Stop ( void );
void Pcf8563_IIC_Stop ( void );
_Bool Si47xx_IIC_WaitAck ( unsigned int TimeOut );
_Bool Pcf8563_IIC_WaitAck ( unsigned int TimeOut );
void Si47xx_IIC_Ack ( void );
void Pcf8563_IIC_Ack ( void );
void Si47xx_IIC_NAck ( void );
void Pcf8563_IIC_NAck ( void );
_Bool Si47xx_IIC_SendByte ( unsigned char Byte );
_Bool Pcf8563_IIC_SendByte ( unsigned char Byte );
uint8_t Si47xx_I2C_RecvByte(void);
uint8_t Pcf8563_I2C_RecvByte(void);
unsigned char Si47xx_IIC_RecvByte ( unsigned char Ack );
unsigned char Pcf8563_IIC_RecvByte ( unsigned char Ack );
_Bool Pcf8563_IIC_WriteByte ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char Byte );
_Bool Pcf8563_IIC_ReadByte ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Val );
_Bool Pcf8563_IIC_WriteBytes ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Buf, unsigned char Num );
_Bool Pcf8563_IIC_ReadBytes ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Buf, unsigned char Num );

#endif
