
/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	fm_rtc_i2c.c
	*
	*	ߣ 		
	*
	*	ڣ 		2018-9-21
	*
	*	汾 		V1.0
	*
	*	˵ 		iicӲʼģiic
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

#include "fm_rtc_i2c.h"
#include "delay.h"
#include "PCF8563.h"
#include "si47xx.h"
//Ͷ
#include "typedef.h"
#include "system_task.h"
IIC_ControlDef IIC_ControlStruct;

/*
************************************************************
*	ƣ	IIC_SpeedCtl
*
*	ܣ	IICٶȿ
*
*	ڲ	ʱ
*
*	ز	
*
*	˵		λ΢
************************************************************
*/
void IIC_SpeedCtl ( unsigned short Speed )
{

	IIC_ControlStruct.IIC_Speed = Speed;

}

/*
************************************************************
*	ƣ	IIC_Read_Speed
*
*	ܣ	ȡIICٶ
*
*	ڲ	
*
*	ز	ٶֵ
*
*	˵		λ΢
************************************************************
*/
unsigned short IIC_Read_Speed ( void )
{

	return IIC_ControlStruct.IIC_Speed;

}

/*
************************************************************
*	ƣ	Si47xx_IIC_Init
*
*	ܣ	Si47xxIICIOʼ
*
*	ڲ	
*
*	ز	
*
*	˵		ʹÿ©ʽԲлIOڵ
*    IIC2:PB10--SCL  PB11--SDA
************************************************************
*/
void Si47xx_IIC_Init ( void )
{
	GPIO_InitTypeDef gpioInitStruct;
	RCC_APB2PeriphClockCmd (SI47XX_IIC_CLK, ENABLE );
	gpioInitStruct.GPIO_Mode = GPIO_Mode_Out_OD;			    //©ȥл뷽
	gpioInitStruct.GPIO_Pin =SI47XX_IIC_SDA_PIN|SI47XX_IIC_SCL_PIN;
	gpioInitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init (SI47XX_IIC_PORT, &gpioInitStruct );
	IIC_SpeedCtl ( 5 );
	Si47xx_SDA_H;												//SDAߣڿ״̬
	Si47xx_SCL_H;												//SCLߣڿ״̬
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_Init
*
*	ܣ	Pcf8563IICIOʼ
*
*	ڲ	
*
*	ز	
*
*	˵		ʹÿ©ʽԲлIOڵ
*    IIC1:PB6--SCL  PB7--SDA
************************************************************
*/
void Pcf8563_IIC_Init ( void )
{
	GPIO_InitTypeDef gpioInitStruct;
	RCC_APB2PeriphClockCmd (PCF8563_IIC_CLK, ENABLE );
	gpioInitStruct.GPIO_Mode = GPIO_Mode_Out_OD;			    //©ȥл뷽
	gpioInitStruct.GPIO_Pin =PCF8563_IIC_SDA_PIN|PCF8563_IIC_SCL_PIN;
	gpioInitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init (PCF8563_IIC_PORT, &gpioInitStruct );
	IIC_SpeedCtl ( 5 );
	Si47xx_SDA_H;												//SDAߣڿ״̬
	Si47xx_SCL_H;												//SCLߣڿ״̬
}

/*
************************************************************
*	ƣ	Si47xx_IIC_Start
*
*	ܣ	IICʼź
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void Si47xx_IIC_Start ( void )
{
	Si47xx_SDA_H;						//SDA
	Si47xx_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ

	Si47xx_SDA_L;						//SCLΪʱSDAһ½شʼź
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ
	Si47xx_SCL_L;						//ǯסSCLߣԱ㷢
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_Start
*
*	ܣ	IICʼź
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/

void Pcf8563_IIC_Start ( void )
{
	Pcf8563_SDA_H;						//SDA
	Pcf8563_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ

	Pcf8563_SDA_L;						//SCLΪʱSDAһ½شʼź
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ
	Pcf8563_SCL_L;						//ǯסSCLߣԱ㷢
}

/*
************************************************************
*	ƣ	Si47xx_IIC_Stop
*
*	ܣ	IICֹͣź
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void Si47xx_IIC_Stop ( void )
{
	Si47xx_SDA_L;						//SDA
	Si47xx_SCL_L;						//SCL
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ

	Si47xx_SCL_H;						//SCL
	Si47xx_SDA_H;						//SDAߣSCLΪʱSDAһشֹͣź
	DelayUs ( IIC_Read_Speed() );
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_Stop
*
*	ܣ	IICֹͣź
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void Pcf8563_IIC_Stop ( void )
{
	Pcf8563_SDA_L;						//SDA
	Pcf8563_SCL_L;						//SCL
	DelayUs ( IIC_Read_Speed() );		//ʱٶȿ

	Pcf8563_SCL_H;						//SCL
	Pcf8563_SDA_H;						//SDAߣSCLΪʱSDAһشֹͣź
	DelayUs ( IIC_Read_Speed() );
}

/*
************************************************************
*	ƣ	Si47xx_IIC_WaitAck
*
*	ܣ	IICȴӦ
*
*	ڲ	
*
*	ز	timeOutʱʱ
*
*	˵		
************************************************************
*/
_Bool Si47xx_IIC_WaitAck ( unsigned int TimeOut )
{
	Si47xx_SDA_H;
	DelayUs ( IIC_Read_Speed() );			//SDA
	Si47xx_SCL_H;
	DelayUs ( IIC_Read_Speed() );			//SCL

	while ( Si47xx_SDA_R )					//SDAΪ1ȴӦźӦ0
	{
		if ( --TimeOut )
		{
			Si47xx_IIC_Stop();				//ʱδյӦֹͣ
			return IIC_ERR;					//ʧ
		}
		DelayUs ( IIC_Read_Speed() );
	}
	Si47xx_SCL_L;							//SCLߣԱշ

	return IIC_OK;							//سɹ
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_WaitAck
*
*	ܣ	IICȴӦ
*
*	ڲ	
*
*	ز	timeOutʱʱ
*
*	˵		
************************************************************
*/
_Bool Pcf8563_IIC_WaitAck ( unsigned int TimeOut )
{
	Pcf8563_SDA_H;
	DelayUs ( IIC_Read_Speed() );			//SDA
	Pcf8563_SCL_H;
	DelayUs ( IIC_Read_Speed() );			//SCL

	while ( Pcf8563_SDA_R )					//SDAΪ1ȴӦźӦ0
	{
		if ( --TimeOut )
		{
			Pcf8563_IIC_Stop();				//ʱδյӦֹͣ
			return IIC_ERR;					//ʧ
		}
		DelayUs ( IIC_Read_Speed() );
	}
	Pcf8563_SCL_L;							//SCLߣԱշ

	return IIC_OK;							//سɹ
}




/*
************************************************************
*	ƣ	Si47xx_IIC_Ack
*
*	ܣ	IICһӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Si47xx_IIC_Ack ( void )
{
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_L;						//SDA
	DelayUs ( IIC_Read_Speed() );
	Si47xx_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_H;
}
/*
************************************************************
*	ƣ	Pcf8563_IIC_Ack
*
*	ܣ	IICһӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Pcf8563_IIC_Ack ( void )
{
	Pcf8563_SCL_L;						//SCL
	Pcf8563_SDA_L;						//SDA
	DelayUs ( IIC_Read_Speed() );
	Pcf8563_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );
	Pcf8563_SCL_L;						//SCL
	Pcf8563_SDA_H;
}



/*
************************************************************
*	ƣ	Si47xx_IIC_NAck
*
*	ܣ	IICһǸӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Si47xx_IIC_NAck ( void )
{
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_H;						//SDA
	DelayUs ( IIC_Read_Speed() );
	Si47xx_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );
	Si47xx_SCL_L;						//SCL
}
/*
************************************************************
*	ƣ	Pcf8563_IIC_NAck
*
*	ܣ	IICһǸӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Pcf8563_IIC_NAck ( void )
{
	Pcf8563_SCL_L;						//SCL
	Pcf8563_SDA_H;						//SDA
	DelayUs ( IIC_Read_Speed() );
	Pcf8563_SCL_H;						//SCL
	DelayUs ( IIC_Read_Speed() );
	Pcf8563_SCL_L;						//SCL
}



/*
************************************************************
*	ƣ	Si47xx_IIC_SendByte
*
*	ܣ	IICһֽ
*
*	ڲ	byteҪ͵ֽ
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
_Bool Si47xx_IIC_SendByte ( unsigned char Byte )
{
	unsigned char count = 0;

	Si47xx_SCL_L;								//ʱӿʼݴ
	for ( ; count < 8; count++ )				//ѭ8Σÿηһbit
	{
		if ( Byte & 0x80 )						//λ
			Si47xx_SDA_H;
		else
			Si47xx_SDA_L;
		Byte <<= 1;					            //byte1λ
		DelayUs ( IIC_Read_Speed() );
		Si47xx_SCL_H;
		DelayUs ( IIC_Read_Speed() );
		Si47xx_SCL_L;
	}
	if ( Si47xx_IIC_WaitAck ( WaitAckTime ) )	//ȴӦ
	{
		Si47xx_IIC_Stop();	                   
		return IIC_ERR;
	}
	else
		return IIC_OK;
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_SendByte
*
*	ܣ	IICһֽ
*
*	ڲ	byteҪ͵ֽ
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
_Bool Pcf8563_IIC_SendByte ( unsigned char Byte )
{
	unsigned char count = 0;

	Pcf8563_SCL_L;								//ʱӿʼݴ
	for ( ; count < 8; count++ )				//ѭ8Σÿηһbit
	{
		if ( Byte & 0x80 )						//λ
			Pcf8563_SDA_H;
		else
			Pcf8563_SDA_L;
		Byte <<= 1;								//byte1λ

		DelayUs ( IIC_Read_Speed() );
		Pcf8563_SCL_H;
		DelayUs ( IIC_Read_Speed() );
		Pcf8563_SCL_L;
	}
	if ( Pcf8563_IIC_WaitAck ( WaitAckTime ) )	//ȴӦ
	{
		Pcf8563_IIC_Stop();	                   
		return IIC_ERR;
	}
	else
		return IIC_OK;
}

/*
************************************************************
*	ƣ	Si47xx_I2C_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	
*
*	ز	յֵ
*
*	˵		
************************************************************
*/
uint8_t Si47xx_I2C_RecvByte()
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		Si47xx_SCL_H;
		DelayUs ( IIC_Read_Speed() );
		if (Si47xx_SDA_R )
		{
			value++;
		}
		Si47xx_SCL_L;
		DelayUs ( IIC_Read_Speed() );
	}
	return value;
}

/*
************************************************************
*	ƣ	Pcf8563_I2C_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	
*
*	ز	յֵ
*
*	˵		
************************************************************
*/

uint8_t Pcf8563_I2C_RecvByte()
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		Pcf8563_SCL_H;
		DelayUs ( IIC_Read_Speed() );
		if (Pcf8563_SDA_R )
		{
			value++;
		}
		Pcf8563_SCL_L;
		DelayUs ( IIC_Read_Speed() );
	}
	return value;
}

/*
************************************************************
*	ƣ	Si47xx_IIC_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	ackACK(0)NACK(1)
*
*	ز	յֽ
*
*	˵		
************************************************************
*/
unsigned char Si47xx_IIC_RecvByte ( unsigned char Ack )
{
	unsigned char count = 0, receive = 0;

	Si47xx_SDA_H;						//SDAߣ©״̬£Աȡ
	for ( ; count < 8; count++ )		//ѭ8Σÿηһbit
	{
		Si47xx_SCL_L;
		DelayUs ( IIC_Read_Speed() );
		Si47xx_SCL_H;
		receive <<= 1;					//һλ
		if ( Si47xx_SDA_R )				//SDAΪ1receiveÿǶbit0+1Ȼһѭһ
			receive++;
		DelayUs ( IIC_Read_Speed() );
	}
	if ( Ack )
		Si47xx_IIC_NAck();
	else
		Si47xx_IIC_Ack();
	return receive;
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	ackACK(0)NACK(1)
*
*	ز	յֽ
*
*	˵		
************************************************************
*/
unsigned char Pcf8563_IIC_RecvByte ( unsigned char Ack )
{
	unsigned char count = 0, receive = 0;

	Pcf8563_SDA_H;						//SDAߣ©״̬£Աȡ
	for ( ; count < 8; count++ )		//ѭ8Σÿηһbit
	{
		Pcf8563_SCL_L;
		DelayUs ( IIC_Read_Speed() );
		Pcf8563_SCL_H;
		receive <<= 1;					//һλ
		if ( Pcf8563_SDA_R )			//SDAΪ1receiveÿǶbit0+1Ȼһѭһ
			receive++;
		DelayUs ( IIC_Read_Speed() );
	}
	if ( Ack )
		Pcf8563_IIC_NAck();
	else
		Pcf8563_IIC_Ack();
	return receive;
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_WriteByte
*
*	ܣ	IICдһ
*
*	ڲ	ackACK(0)NACK(1)
*
*	ز	յֽ
*
*	˵		
************************************************************
*/
_Bool Pcf8563_IIC_WriteByte ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char Byte )
{
	Pcf8563_IIC_Start();						//ʼź
	//豸ַ(д)
	if ( Pcf8563_IIC_SendByte ( SlaveAddr ) )	//ȴӦ
		return IIC_ERR;
	//ͼĴַ
	if ( Pcf8563_IIC_SendByte ( RegAddr ) )		//ȴӦ
		return IIC_ERR;
	//
	if ( Pcf8563_IIC_SendByte ( Byte ) )		//ȴӦ
		return IIC_ERR;
	Pcf8563_IIC_Stop();							//ֹͣź
	return IIC_OK;
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_WriteByte
*
*	ܣ	IICȡһֽ
*
*	ڲ	slaveAddrӻַ
*				regAddrĴַ
*				valҪȡݻ
*
*	ز	0-ɹ		1-ʧ
*
*	˵		
************************************************************
*/
_Bool Pcf8563_IIC_ReadByte ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Val )
{

	Pcf8563_IIC_Start();							//ʼź
	//豸ַ(д)
	if ( Pcf8563_IIC_SendByte ( SlaveAddr ) )		//ȴӦ
		return IIC_ERR;
	//ͼĴַ
	if ( Pcf8563_IIC_SendByte ( RegAddr ) )			//ȴӦ
		return IIC_ERR;
	Pcf8563_IIC_Start();				   			//ź
	//豸ַ()
	if ( Pcf8563_IIC_SendByte ( SlaveAddr + 1 ) )	//ȴӦ
		return IIC_ERR;
	*Val = Pcf8563_IIC_RecvByte ( NACK );  			//һӦźţȡ
	Pcf8563_IIC_Stop();					   			//ֹͣź
	return IIC_OK;
}

/*
************************************************************
*	ƣ	Pcf8563_IIC_WriteBytes
*
*	ܣ	IICд
*
*	ڲ	slaveAddrӻַ
*				regAddrĴַ
*				bufҪдݻ
*               numݳ
*
*	ز	0-ɹ		1-ʧ
*
*	˵		
************************************************************
*/
_Bool Pcf8563_IIC_WriteBytes ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Buf, unsigned char Num )
{
	Pcf8563_IIC_Start();						//ʼź
	//豸ַ(д)
	if ( Pcf8563_IIC_SendByte ( SlaveAddr ) )	//ȴӦ
		return IIC_ERR;
	//ͼĴַ
	if ( Pcf8563_IIC_SendByte ( RegAddr ) )		//ȴӦ
		return IIC_ERR;
	while ( Num-- )								//ѭд
	{
		//
		if ( Pcf8563_IIC_SendByte ( *Buf ) )	//ȴӦ
			return IIC_ERR;
		Buf++;									//ָƫƵһ
		DelayUs ( 10 );
	}
	Pcf8563_IIC_Stop();							//ֹͣź
	return IIC_OK;
}



/*
************************************************************
*	ƣ	Pcf8563_IIC_ReadBytes
*
*	ܣ	IIC
*
*	ڲ	slaveAddrӻַ
*				regAddrĴַ
*				bufҪдݻ
*               numݳ
*
*	ز	0-ɹ		1-ʧ
*
*	˵		
************************************************************
*/
_Bool Pcf8563_IIC_ReadBytes ( unsigned char SlaveAddr, unsigned char RegAddr, unsigned char *Buf, unsigned char Num )
{
	Pcf8563_IIC_Start();							//ʼź
	//豸ַ(д)
	if ( Pcf8563_IIC_SendByte ( SlaveAddr ) )		//ȴӦ
		return IIC_ERR;
	//ͼĴַ
	if ( Pcf8563_IIC_SendByte ( RegAddr ) )			//ȴӦ
		return IIC_ERR;
	Pcf8563_IIC_Start();				   			//ź
	//豸ַ()
	if ( Pcf8563_IIC_SendByte ( SlaveAddr + 1 ) )	//ȴӦ
		return IIC_ERR;
	while ( Num-- )
	{
		//ƫƵһݴ洢ַ
		if ( Num == 0 )
		{
			*Buf = Pcf8563_IIC_RecvByte ( NACK );	//һҪNOACK
		}
		else
		{
			*Buf = Pcf8563_IIC_RecvByte ( ACK );	//ӦACK
		}
		Buf++;
	}
	Pcf8563_IIC_Stop();
	return IIC_OK;
}








