
/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	fm_rtc_i2c.c
	*
	*	ߣ 		
	*
	*	ڣ 		2018-9-21
	*
	*	汾 		V1.0
	*
	*	˵ 		iicӲʼģiic
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

#include "si47xx.h"
#include "fm_i2c.h"



static void Delay(void)
{
	int i=0,j=0;
	
	for(i=0;i<1;i++)
	{
		for(j=0;j<100;j++)
		{;}
	}
}



/*
************************************************************
*	ƣ	Si47xx_IIC_Init
*
*	ܣ	Si47xxIICIOʼ
*
*	ڲ	
*
*	ز	
*
*	˵		ʹÿ©ʽԲлIOڵ
*    IIC2:PB10--SCL  PB11--SDA
************************************************************
*/
void Si47xx_IIC_Init ( void )
{
	
	__HAL_RCC_GPIOA_CLK_ENABLE();
	GPIO_InitTypeDef GPIO_InitStruct = {0};       // SCLܽųʼ  PA15
	GPIO_InitStruct.Pin = GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;      
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

	  __HAL_RCC_GPIOB_CLK_ENABLE();
  GPIO_InitStruct.Pin = GPIO_PIN_7;          // SDAܽųʼ   PB7
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;   
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

	
	Si47xx_SDA_H;												//SDAߣڿ״̬
	Si47xx_SCL_H;												//SCLߣڿ״̬
	
}

/*
************************************************************
*	ƣ	Si47xx_IIC_Start
*
*	ܣ	IICʼź
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void Si47xx_IIC_Start ( void )
{
	Si47xx_SDA_H;						//SDA
	Si47xx_SCL_H;						//SCL
	Delay();		//ʱٶȿ

	Si47xx_SDA_L;						//SCLΪʱSDAһ½شʼź
	Delay();		//ʱٶȿ
	Si47xx_SCL_L;						//ǯסSCLߣԱ㷢
}



void Si47xx_IIC_Stop ( void )
{
	Si47xx_SDA_L;						//SDA
	Si47xx_SCL_L;						//SCL
	Delay();		//ʱٶȿ

	Si47xx_SCL_H;						//SCL
	Si47xx_SDA_H;						//SDAߣSCLΪʱSDAһشֹͣź
	Delay();
}


/*
************************************************************
*	ƣ	Si47xx_IIC_WaitAck
*
*	ܣ	IICȴӦ
*
*	ڲ	
*
*	ز	timeOutʱʱ
*
*	˵		
************************************************************
*/
_Bool Si47xx_IIC_WaitAck ( unsigned int TimeOut )
{
	Si47xx_SDA_H;
	Delay();			//SDA
	Si47xx_SCL_H;
	Delay();			//SCL

	while ( Si47xx_SDA_R )					//SDAΪ1ȴӦźӦ0
	{
		if ( --TimeOut )
		{
			Si47xx_IIC_Stop();				//ʱδյӦֹͣ
			return IIC_ERR;					//ʧ
		}
		Delay();
	}
	Si47xx_SCL_L;							//SCLߣԱշ

	return IIC_OK;							//سɹ
}


/*
************************************************************
*	ƣ	Si47xx_IIC_Ack
*
*	ܣ	IICһӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Si47xx_IIC_Ack ( void )
{
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_L;						//SDA
	Delay();
	Si47xx_SCL_H;						//SCL
	Delay();
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_H;
}


/*
************************************************************
*	ƣ	Si47xx_IIC_NAck
*
*	ܣ	IICһǸӦ
*
*	ڲ	
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
void Si47xx_IIC_NAck ( void )
{
	Si47xx_SCL_L;						//SCL
	Si47xx_SDA_H;						//SDA
	Delay();
	Si47xx_SCL_H;						//SCL
	Delay();
	Si47xx_SCL_L;						//SCL
}


/*
************************************************************
*	ƣ	Si47xx_IIC_SendByte
*
*	ܣ	IICһֽ
*
*	ڲ	byteҪ͵ֽ
*
*	ز	
*
*	˵		SDAΪʱSCLһһӦź
************************************************************
*/
_Bool Si47xx_IIC_SendByte ( unsigned char Byte )
{
	unsigned char count = 0;

	Si47xx_SCL_L;								//ʱӿʼݴ
	for ( ; count < 8; count++ )				//ѭ8Σÿηһbit
	{
		if ( Byte & 0x80 )						//λ
			Si47xx_SDA_H;
		else
			Si47xx_SDA_L;
		Byte <<= 1;					            //byte1λ
		Delay();
		Si47xx_SCL_H;
		Delay();
		Si47xx_SCL_L;
	}
	if ( Si47xx_IIC_WaitAck ( WaitAckTime ) )	//ȴӦ
	{
		Si47xx_IIC_Stop();	                   
		return IIC_ERR;
	}
	else
		return IIC_OK;
}


/*
************************************************************
*	ƣ	Si47xx_I2C_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	
*
*	ز	յֵ
*
*	˵		
************************************************************
*/
uint8_t Si47xx_I2C_RecvByte()
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		Si47xx_SCL_H;
		Delay();
		if (Si47xx_SDA_R )
		{
			value++;
		}
		Si47xx_SCL_L;
		Delay();
	}
	return value;
}



/*
************************************************************
*	ƣ	Si47xx_IIC_RecvByte
*
*	ܣ	IICһֽ
*
*	ڲ	ackACK(0)NACK(1)
*
*	ز	յֽ
*
*	˵		
************************************************************
*/
unsigned char Si47xx_IIC_RecvByte ( unsigned char Ack )
{
	unsigned char count = 0, receive = 0;

	Si47xx_SDA_H;						//SDAߣ©״̬£Աȡ
	for ( ; count < 8; count++ )		//ѭ8Σÿηһbit
	{
		Si47xx_SCL_L;
		Delay();
		Si47xx_SCL_H;
		receive <<= 1;					//һλ
		if ( Si47xx_SDA_R )				//SDAΪ1receiveÿǶbit0+1Ȼһѭһ
			receive++;
		Delay();
	}
	if ( Ack )
		Si47xx_IIC_NAck();
	else
		Si47xx_IIC_Ack();
	return receive;
}




